; Changes
; 1. Hanging note bug fixed
; 2. ADPCM problem fixed
; 3. Overall speedup - removed all debug x-bus trace port access


    org	0
;
reset_vector:
    ljmp	reset_handler
;
int0_vector:
    ljmp	int0_handler
;
    db 0xFF,0xFF,0xFF,0xFF,0xFF
;
timer0_vector:
    ljmp	timer0_handler
;
    db 0xFF,0xFF,0xFF,0xFF,0xFF
;
int1_vector:
    ljmp	int1_handler
;
int0_handler:
    setb	p1.2
    push	acc
    push	dpl
    push	dph
    push	rb0r0
    mov	dptr,#int0_table
    mov	a,rb1r3
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
int0_table:
        ;db	1eh,0fh,12h,15h,18h,1bh,1eh,1eh
    ;db	1eh,1eh,1eh,1eh,1eh,1eh,1eh

        db int0_op_none_handler - int0_table
        db int0_op1_vector - int0_table
        db int0_op2_vector - int0_table
        db int0_op3_vector - int0_table
        db int0_op4_vector - int0_table
        db int0_op5_vector - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
        db int0_op_none_handler - int0_table
;
int0_op1_vector:
    ljmp	int0_op1_handler
;
int0_op2_vector:
    ljmp	int0_op2_handler
;
int0_op3_vector:
    ljmp	int0_op3_handler
;
int0_op4_vector:
    ljmp	int0_op4_handler
;
int0_op5_vector:
    ljmp	int0_op5_handler
;
int0_op_none_handler:
    clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
int1_handler:
    clr	p1.2
    push	acc
    push	dpl
    push	dph
    push	rb0r0
    mov	r0,#6
    movx	a,@r0
    jnb	acc.0,X0083
    lcall	X00ca
X0083:	mov	r0,#6
    movx	a,@r0
    jnb	acc.1,X008c
    lcall	X0145
X008c:	pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
timer0_handler:
    jb	24h.5,X00ba
    jnb	23h.6,X00a4
    mov	tl0,rb3r1
    mov	th0,rb3r2
    ljmp	X00a8
;
X00a4:	clr	et0
    clr	tr0
X00a8:	clr	p1.7
    setb	p1.7
    reti	
;
X00ba:	inc	r5
    cjne	r5,#0,X00c3
    inc	r6
    cjne	r6,#0,X00c3
    inc	r7
X00c3:	mov	tl0,#2fh
    mov	th0,#0f8h
    reti	
;
X00ca:	jb	24h.1,X0122
    jnb	24h.2,X00e8
    mov	r0,#7
X00d2:	jb	p1.1,X00d9
    movx	a,@r0
    jb	acc.0,X00d2
X00d9:	mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	X013c
;
X00e8:	mov	r0,#8
    movx	a,@r0
    anl	a,#0e7h
    orl	a,#2
    movx	@r0,a
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    jnb	2fh.1,X0102
    lcall	X0b09
X0102:	mov	r0,#6
    setb	2fh.0
    mov	31h,#0
    mov	32h,#0
    jnb	23h.1,X0117
    lcall	X134a
    clr	23h.1
    ljmp	X0144
;
X0117:	jnb	23h.0,X0144
    lcall	X1341
    clr	23h.0
    ljmp	X0144
;
X0122:	clr	24h.2
    clr	24h.1
    mov	a,rb2r1
    mov	r0,#0bh
    movx	@r0,a
    mov	a,rb2r2
    mov	r0,#0ch
    movx	@r0,a
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X013c:	mov	r0,#8
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
X0144:	ret	
;
X0145:	jb	24h.3,X0195
    jnb	24h.4,X0162
    mov	r0,#7
X014d:	jb	p1.1,X0154
    movx	a,@r0
    jb	acc.1,X014d
X0154:	mov	r0,#10h
    movx	a,@r0
    anl	a,#0
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	X01ae
;
X0162:	mov	r0,#10h
    movx	a,@r0
    anl	a,#0e7h
    orl	a,#2
    movx	@r0,a
    mov	r0,#10h
    movx	a,@r0
    anl	a,#0
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    jnb	2fh.0,X017b
    lcall	X0b09
X017b:	mov	r0,#6
    setb	2fh.1
    jnb	23h.3,X018a
    lcall	X134a
    clr	23h.3
    ljmp	X01b6
;
X018a:	jnb	23h.2,X01b6
    lcall	X1341
    clr	23h.2
    ljmp	X01b6
;
X0195:	clr	24h.4
    clr	24h.3
    mov	a,rb2r5
    mov	r0,#13h
    movx	@r0,a
    mov	a,rb2r6
    mov	r0,#14h
    movx	@r0,a
    mov	r0,#10h
    movx	a,@r0
    anl	a,#0
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X01ae:	mov	r0,#10h
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
X01b6:	ret	
;
int0_op2_handler:
    jnb	p1.1,X01bf
    setb	24h.0
    ljmp	X0270
;
X01bf:	dec	r3
    cjne	r3,#0,X01ed
    clr	a
    cjne	a,21h,X0220
    cjne	a,22h,X021e
    jb	24h.1,X0241
    jb	24h.2,X01f0
    clr	24h.1
    clr	24h.2
    clr	ex0
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    setb	2fh.0
    jnb	2fh.1,X01ea
    lcall	X0b09
X01ea:	ljmp	X0270
;
X01ed:	ljmp	X023b
;
X01f0:	mov	21h,rb1r6
    mov	22h,rb1r7
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0205:	movx	a,@r0
    jnb	acc.6,X0205
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#4
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	X0270
;
X021e:	dec	22h
X0220:	dec	21h
    mov	r3,#4
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0233:	movx	a,@r0
    jnb	acc.6,X0233
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
X023b:	lcall	X1221
    ljmp	X0270
;
X0241:	clr	24h.2
    clr	24h.1
    mov	21h,rb2r1
    mov	22h,rb2r2
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X025a:	movx	a,@r0
    jnb	acc.6,X025a
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#4
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X0270:	clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
int0_op4_handler:
    jnb	p1.1,X028d
    setb	24h.0
    ljmp	X033e
;
X028d:	dec	r3
    cjne	r3,#0,X02bb
    clr	a
    cjne	a,21h,X02ee
    cjne	a,22h,X02ec
    jb	24h.1,X030f
    jb	24h.2,X02be
    clr	24h.1
    clr	24h.2
    clr	ex0
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    setb	2fh.0
    jnb	2fh.1,X02b8
    lcall	X0b09
X02b8:	ljmp	X033e
;
X02bb:	ljmp	X0309
;
X02be:	mov	21h,rb1r6
    mov	22h,rb1r7
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X02d3:	movx	a,@r0
    jnb	acc.6,X02d3
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#2
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	X033e
;
X02ec:	dec	22h
X02ee:	dec	21h
    mov	r3,#2
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0301:	movx	a,@r0
    jnb	acc.6,X0301
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
X0309:	lcall	X1278
    ljmp	X033e
;
X030f:	clr	24h.2
    clr	24h.1
    mov	21h,rb2r1
    mov	22h,rb2r2
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0328:	movx	a,@r0
    jnb	acc.6,X0328
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#2
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X033e:	clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
int0_op3_handler:
    jnb	p1.1,X035b
    setb	24h.0
    ljmp	X040a
;
X035b:	dec	r3
    cjne	r3,#0,X0387
    clr	a
    cjne	a,21h,X038c
    cjne	a,22h,X038a
    jb	24h.1,X03db
    jb	24h.2,X03ad
    clr	24h.1
    clr	24h.2
    clr	ex0
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    jnb	2fh.1,X0384
    lcall	X0b09
X0384:	ljmp	X040a
;
X0387:	ljmp	X03a7
;
X038a:	dec	22h
X038c:	dec	21h
    mov	r3,#3
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X039f:	movx	a,@r0
    jnb	acc.6,X039f
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
X03a7:	lcall	X12c3
    ljmp	X040a
;
X03ad:	mov	21h,rb1r6
    mov	22h,rb1r7
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X03c2:	movx	a,@r0
    jnb	acc.6,X03c2
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#3
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	X040a
;
X03db:	clr	24h.2
    clr	24h.1
    mov	21h,rb2r1
    mov	22h,rb2r2
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X03f4:	movx	a,@r0
    jnb	acc.6,X03f4
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#3
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X040a:	clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
int0_op1_handler:
    jnb	p1.1,X0427
    setb	24h.0
    ljmp	X044b
;
X0427:	clr	a
    cjne	a,21h,X0449
    cjne	a,22h,X0447
    clr	ex0
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    setb	2fh.0
    jnb	2fh.1,X044b
    lcall	X0b09
    ljmp	X044b
;
X0447:	dec	22h
X0449:	dec	21h
X044b:	clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
int0_op5_handler:
    mov	dptr,#int0_op5_data
    mov	a,r7
    movc	a,@a+dptr
    cjne	a,#0,X046c
    mov	r7,#0
    clr	a
    movc	a,@a+dptr
X046c:	mov	r0,#19h
    movx	@r0,a
    inc	r7
    clr	p1.2
    pop	rb0r0
    pop	dph
    pop	dpl
    pop	acc
    reti	
;
reset_handler:
    setb	p1.2
    clr	ea
    setb	p1.7
    setb	2fh.0
    setb	2fh.1
    clr	p1.4
    clr	p2.6
    mov	sp,#0c0h
    clr	p1.5
    setb	p2.7
    mov	scon,#42h
    mov	th1,#0fch
    mov	tl1,#0fch
    mov	tmod,#21h
    mov	pcon,#80h
    setb	tr1
    setb	ren
    setb	it0
    setb	it1
    mov	a,#34h
    cjne	a,31h,X04ce
    mov	a,#12h
    cjne	a,32h,X04ce
    mov	31h,#0
    mov	32h,#0
    ljmp	X050f
;
X04ce:	mov	r0,#4
    mov	a,#60h
    movx	@r0,a
    mov	r0,#8
    mov	a,#2
    movx	@r0,a
    mov	r0,#9
    mov	a,#0f8h
    movx	@r0,a
    mov	r0,#5
    mov	a,#0c3h
    movx	@r0,a
    mov	r0,#0eh
    mov	a,#5
    movx	@r0,a
    mov	r0,#0eh
    mov	a,#4
    movx	@r0,a
    mov	r0,#10h
    mov	a,#2
    movx	@r0,a
    mov	r0,#16h
    mov	a,#5
    movx	@r0,a
    mov	r0,#16h
    mov	a,#4
    movx	@r0,a
    mov	r7,#0
    mov	25h,#0aah
    mov	26h,#96h
    mov	rb1r6,#0ffh
    mov	rb1r7,#7
    mov	37h,#38h
    mov	23h,#0
X050f:	mov	r0,#5
    movx	a,@r0
    setb	acc.1
    movx	@r0,a
    mov	rb1r3,#0
    mov	2ch,#0
    mov	2dh,#0
    mov	2bh,#0
    mov	24h,#0
    clr	p2.5
    setb	p2.4
    clr	2fh.4
    clr	2fh.3
    clr	2fh.2
    setb	ea
    mov	a,#0aah
X0532:	jb	p1.0,X0532
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
X053a:	jb	24h.0,X0564
command_loop:
    clr	p1.2
    jb	23h.5,X0552
    jnb	p1.6,X0555
    lcall	X0c86
X0552:	lcall	X0c9e
X0555:	setb	p1.2
    jnb	p1.1,command_loop
X0564:	clr	ea
    clr	24h.0
    mov	30h,command
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	command,a
    swap	a
    anl	a,#0fh
    cjne	a,#0dh,X057b
    ljmp	cmd_GD
;
X057b:	setb	ea
    clr	p1.2
    mov	dptr,#command_dispatch_table
    movc	a,@a+dptr
    jmp	@a+dptr
;
    sjmp	X053a
;
;X0590:	db	12h,15h,1eh,21h,27h,10h,10h,18h
;    db	2ah,1bh,10h,36h,33h,30h,2dh,24h

command_dispatch_table:
     db command_dispatch_G0 - command_dispatch_table
     db command_dispatch_G1 - command_dispatch_table
     db command_dispatch_G2 - command_dispatch_table
     db command_dispatch_G3 - command_dispatch_table
     db command_dispatch_G4 - command_dispatch_table
     db cmd_NONE            - command_dispatch_table
     db cmd_NONE            - command_dispatch_table
     db command_dispatch_G7 - command_dispatch_table
     db command_dispatch_G8 - command_dispatch_table
     db command_dispatch_G9 - command_dispatch_table
     db cmd_NONE            - command_dispatch_table
     db command_dispatch_GB - command_dispatch_table
     db command_dispatch_GC - command_dispatch_table
     db command_dispatch_GD - command_dispatch_table
     db command_dispatch_GE - command_dispatch_table
     db command_dispatch_GF - command_dispatch_table

;
cmd_NONE:
    sjmp	X053a
command_dispatch_G0:
    ljmp	cmd_G0
command_dispatch_G1:
    ljmp	cmd_G1
command_dispatch_G7:
    ljmp	cmd_G7
command_dispatch_G9:
    ljmp	cmd_G9
command_dispatch_G2:
    ljmp	cmd_G2
command_dispatch_G3:
    ljmp	cmd_G3
command_dispatch_GF:
    ljmp	cmd_GF
command_dispatch_G4:
    ljmp	cmd_G4
command_dispatch_G8:
    ljmp	cmd_G8
command_dispatch_GE:
    ljmp	cmd_GE
command_dispatch_GD:
    ljmp	cmd_GD
command_dispatch_GC:
    ljmp	cmd_GC
command_dispatch_GB:
    ljmp	cmd_GB
;
cmd_GC:	lcall	X0af1
    mov	r0,#4
    movx	a,@r0
    anl	a,#0f0h
    jnb	command_bit3,X05dd
    orl	a,#5
    mov	2eh,a
    setb	23h.1
    ljmp	X05e3
;
X05dd:	orl	a,#4
    mov	2eh,a
    setb	23h.0
X05e3:	jnb	command_bit2,X05eb
    setb	24h.2
    ljmp	X0606
;
X05eb:	jnb	24h.2,X0606
    clr	24h.2
    lcall	X132f
    lcall	X132f
    mov	rb2r1,a
    lcall	X132f
    mov	rb2r2,a
    setb	24h.1
    clr	2fh.0
    setb	ex1
    ljmp	X067c
;
X0606:	jnb	command_bit1,X0618
    jb	command_bit3,X0612
    lcall	X1353
    ljmp	X0627
;
X0612:	lcall	X135c
    ljmp	X0627
;
X0618:	jb	command_bit3,X0621
    lcall	X1341
    ljmp	X0627
;
X0621:	lcall	X134a
    ljmp	X0627
;
X0627:	jnb	command_bit0,X062a
X062a:	lcall	X132f
    mov	2ch,a
    mov	a,2eh
    clr	acc.4
    jnb	2ch.4,X0638
    setb	acc.4
X0638:	setb	acc.6
    jnb	2ch.5,X063f
    clr	acc.6
X063f:	mov	r0,#4
    movx	@r0,a
    clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
    lcall	X132f
    mov	rb1r6,a
    mov	r0,#0bh
    movx	@r0,a
    lcall	X132f
    mov	rb1r7,a
    mov	r0,#0ch
    movx	@r0,a
    setb	2fh.4
    setb	ex1
    clr	2fh.0
    clr	ea
    mov	r0,#8
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#16h
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    mov	r0,#0eh
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    setb	ea
X067c:	ljmp	X053a
;
cmd_GB:	lcall	X0af1
    mov	r0,#4
    movx	a,@r0
    anl	a,#0f0h
    jnb	command_bit3,X0693
    orl	a,#4
    mov	2eh,a
    setb	23h.3
    ljmp	X0699
;
X0693:	orl	a,#5
    mov	2eh,a
    setb	23h.2
X0699:	jnb	command_bit2,X06a1
    setb	24h.4
    ljmp	X06bc
;
X06a1:	jnb	24h.4,X06bc
    clr	24h.4
    lcall	X132f
    lcall	X132f
    mov	rb2r5,a
    lcall	X132f
    mov	rb2r6,a
    setb	24h.3
    clr	2fh.1
    setb	ex1
    ljmp	X0726
;
X06bc:	jnb	command_bit1,X06ce
    jb	command_bit3,X06c8
    lcall	X1353
    ljmp	X06dd
;
X06c8:	lcall	X135c
    ljmp	X06dd
;
X06ce:	jb	command_bit3,X06d7
    lcall	X1341
    ljmp	X06dd
;
X06d7:	lcall	X134a
    ljmp	X06dd
;
X06dd:	jnb	command_bit0,X06e0
X06e0:	lcall	X132f
    mov	2dh,a
    mov	a,2eh
    clr	acc.5
    jnb	2dh.4,X06ee
    setb	acc.5
X06ee:	setb	acc.7
    jnb	2dh.5,X06f5
    clr	acc.7
X06f5:	mov	r0,#4
    movx	@r0,a
    lcall	X132f
    mov	rb1r4,a
    mov	r0,#13h
    movx	@r0,a
    lcall	X132f
    mov	rb1r5,a
    mov	r0,#14h
    movx	@r0,a
    setb	2fh.4
    setb	ex1
    clr	2fh.1
    clr	ea
    mov	r0,#10h
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#16h
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    mov	r0,#0eh
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    setb	ea
X0726:	ljmp	X053a
;
cmd_G0:	mov	dptr,#group_0_dispatch_table
    mov	a,command
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
;X0732:	db	75h,0f8h,10h,43h,4ch,34h,55h,5ah
;    db	6ch,91h,67h,9dh,0c8h,75h,78h,86h

group_0_dispatch_table:
     db cmd_00 - group_0_dispatch_table
     db cmd_01 - group_0_dispatch_table
     db cmd_02 - group_0_dispatch_table
     db cmd_03 - group_0_dispatch_table
     db cmd_04 - group_0_dispatch_table
     db cmd_05 - group_0_dispatch_table
     db cmd_06 - group_0_dispatch_table
     db cmd_07 - group_0_dispatch_table
     db cmd_08 - group_0_dispatch_table
     db cmd_09 - group_0_dispatch_table
     db cmd_0A - group_0_dispatch_table
     db cmd_0B - group_0_dispatch_table
     db cmd_0C - group_0_dispatch_table
     db cmd_0D - group_0_dispatch_table
     db cmd_0E - group_0_dispatch_table
     db cmd_0F - group_0_dispatch_table

;
cmd_02:	lcall	X132f
    mov	r0,#80h
    movx	@r0,a
    mov	a,#0f2h
    mov	2eh,a
    mov	r0,#81h
    movx	@r0,a
X074f:	mov	r0,#80h
    movx	a,@r0
    jb	p1.1,X0763
    cjne	a,2eh,X074f
    mov	r0,#10h
    movx	a,@r0
    anl	a,#0
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X0763:	ljmp	X07c0
;
cmd_05:	lcall	X132f
    mov	r0,#80h
    movx	@r0,a
    lcall	X132f
    mov	r0,#81h
    movx	@r0,a
    ljmp	X07c0
;
cmd_03:	mov	r0,#80h
    movx	a,@r0
    lcall	X1338
    ljmp	X07c0
;
cmd_04:	lcall	X132f
    mov	r0,#82h
    movx	@r0,a
    ljmp	X07c0
;
cmd_06:	inc	2bh
    ljmp	X07c0
;
cmd_07:	mov	a,2bh
    cjne	a,#0,X0794
    ljmp	X07c0
;
X0794:	dec	2bh
    ljmp	X07c0
;
cmd_0A:	mov	a,2bh
    lcall	X1338
cmd_08:	mov	r0,#82h
    movx	a,@r0
    lcall	X1338
    ljmp	X07c0
;
cmd_00:
cmd_0D:
    ljmp	command_loop
;
cmd_0E:	lcall	X132f
    mov	b,a
    lcall	X132f
    mov	r0,b
    movx	@r0,a
    ljmp	command_loop
;
cmd_0F:	lcall	X132f
    mov	r0,a
    movx	a,@r0
    lcall	X1338
X07c0:	ljmp	command_loop
;
cmd_09:	mov	a,rb1r0
    lcall	X1338
    mov	a,rb1r1
    lcall	X1338
    sjmp	X07c0
;
cmd_0B:	lcall	X132f
    mov	21h,a
    mov	r0,#80h
    movx	@r0,a
    mov	a,#0c0h
    mov	2eh,a
    mov	r0,#81h
    movx	@r0,a
X07de:	mov	r0,#80h
    movx	a,@r0
    cjne	a,2eh,X07de
X07e4:	lcall	X132f
    mov	r0,#80h
    movx	@r0,a
    lcall	X132f
    mov	r0,#81h
    movx	@r0,a
    clr	a
    cjne	a,21h,X07f6
    sjmp	X07c0
;
X07f6:	dec	21h
    sjmp	X07e4
;
cmd_0C:	lcall	X132f
    mov	21h,a
    mov	r0,#80h
    movx	@r0,a
    mov	a,#0c1h
    mov	2eh,a
    mov	r0,#81h
    movx	@r0,a
X0809:	mov	r0,#80h
    movx	a,@r0
    cjne	a,2eh,X0809
    mov	a,2eh
    mov	r0,#81h
    movx	@r0,a
X0814:	mov	r0,#80h
    movx	a,@r0
    lcall	X1338
    mov	r0,#80h
    movx	a,@r0
    lcall	X1338
    clr	a
    cjne	a,21h,X0826
    sjmp	X07c0
;
X0826:	dec	21h
    sjmp	X0814
;
cmd_01:	mov	a,2bh
    cjne	a,#0,X07c0
    lcall	X1338
    mov	a,#0
    mov	33h,a
    mov	34h,a
    mov	r0,#80h
    movx	@r0,a
    mov	r0,#81h
    movx	@r0,a
    lcall	X132f
    clr	c
    subb	a,#4
    mov	21h,a
    lcall	X132f
    jnc	X084c
    dec	a
X084c:	mov	22h,a
    mov	a,#8ch
    mov	r0,#82h
    movx	@r0,a
    mov	a,#8ah
    mov	r0,#82h
    movx	@r0,a
X0858:	lcall	X132f
    mov	r0,#83h
    movx	@r0,a
    add	a,33h
    mov	33h,a
    jnc	X0866
    inc	34h
X0866:	clr	a
    cjne	a,21h,X08aa
    cjne	a,22h,X08a8
    lcall	X132f
    mov	35h,a
    lcall	X132f
    mov	36h,a
    mov	a,#0
    mov	r0,#82h
    movx	@r0,a
    mov	a,#70h
    mov	r0,#82h
    movx	@r0,a
    mov	a,33h
    cjne	a,35h,X0896
    mov	a,34h
    cjne	a,36h,X0896
    mov	r0,#80h
    movx	a,@r0
    cjne	a,#0aah,X0898
    mov	a,#0
    ljmp	X0898
;
X0896:	mov	a,#0ffh
X0898:	lcall	X1338
    lcall	X132f
    mov	rb1r0,a
    lcall	X132f
    mov	rb1r1,a
    ljmp	X07c0
;
X08a8:	dec	22h
X08aa:	dec	21h
    sjmp	X0858
;
cmd_G4:	mov	dptr,#group_4_dispatch_table
    mov	a,command
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
;X08b7:	db	6fh,82h,82h,9fh,10h,15h,1ah,1fh
;    db	0c0h,24h,24h,24h,51h,60h,27h,2ch
group_4_dispatch_table:
     db cmd_40 - group_4_dispatch_table
     db cmd_41 - group_4_dispatch_table
     db cmd_42 - group_4_dispatch_table
     db cmd_43 - group_4_dispatch_table
     db cmd_44 - group_4_dispatch_table
     db cmd_45 - group_4_dispatch_table
     db cmd_46 - group_4_dispatch_table
     db cmd_47 - group_4_dispatch_table
     db cmd_48 - group_4_dispatch_table
     db cmd_49 - group_4_dispatch_table
     db cmd_4A - group_4_dispatch_table
     db cmd_4B - group_4_dispatch_table
     db cmd_4C - group_4_dispatch_table
     db cmd_4D - group_4_dispatch_table
     db cmd_4E - group_4_dispatch_table
     db cmd_4F - group_4_dispatch_table

;
cmd_44:	setb	2fh.3
    ljmp	X0984
;
cmd_45:	clr	2fh.3
    ljmp	X0984
;
cmd_46:	setb	2fh.2
    ljmp	X0984
;
cmd_47:	clr	2fh.2
    ljmp	X0984
;
cmd_49:
cmd_4A:
cmd_4B:
    ljmp	command_loop
;
cmd_4E:	clr	23h.6
    ljmp	X08f1
;
cmd_4F:	jnb	23h.6,X08ef
    clr	23h.6
    clr	tr0
    clr	et0
    ljmp	X0984
;
X08ef:	setb	23h.6
X08f1:	lcall	X132f
    cpl	a
    mov	tl0,a
    mov	rb3r1,a
    lcall	X132f
    cpl	a
    mov	th0,a
    mov	rb3r2,a
    setb	et0
    setb	tr0
    ljmp	X0984
;
cmd_4C:	lcall	X132f
    anl	a,#3
    add	a,#1bh
    mov	r0,a
    lcall	X132f
    movx	@r0,a
    ljmp	X0984
;
cmd_4D:	lcall	X132f
    anl	a,#3
    add	a,#1bh
    mov	r0,a
    mov	a,@r0
    lcall	X1338
    ljmp	X0984
;
cmd_40:	lcall	X132f
    cjne	a,#0ebh,X092c
X092c:	jc	X0930
    mov	a,#0ebh
X0930:	lcall	convert_samplerate
    lcall	X0ad9
    ljmp	X0984
;
cmd_41:
cmd_42:
    jnb	p1.1,cmd_41
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r4,a
X0943:	jnb	p1.1,X0943
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r3,a
    lcall	X0a78
    lcall	X0ad9
    ljmp	X0984
;
cmd_43:	jnb	p1.1,cmd_43
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r4,a
X0960:	jnb	p1.1,X0960
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r3,a
    lcall	X0a78
    mov	r0,#9
    mov	37h,a
    movx	@r0,a
    clr	23h.7
    ljmp	X0984
;
cmd_48:	lcall	X132f
    mov	rb1r6,a
    lcall	X132f
    mov	rb1r7,a
    ljmp	X0984
;
X0984:	ljmp	command_loop
;
convert_samplerate:
    mov	dptr,#samplerate_table
    movc	a,@a+dptr
    ret	
;
samplerate_table:	db	15h,16h,16h,16h,16h,16h,16h,16h
    db	16h,16h,16h,16h,17h,17h,17h,17h
    db	17h,17h,17h,17h,17h,17h,18h,18h
    db	18h,18h,18h,18h,18h,18h,18h,18h
    db	19h,19h,19h,19h,19h,19h,19h,19h
    db	1ah,1ah,1ah,1ah,1ah,1ah,1ah,1ah
    db	1bh,1bh,1bh,1bh,1bh,1bh,1bh,1bh
    db	1ch,1ch,1ch,1ch,1ch,1ch,1ch,1dh
    db	1dh,1dh,1dh,1dh,1dh,1eh,1eh,1eh
    db	1eh,1eh,1eh,1fh,1fh,1fh,1fh,1fh
    db	1fh,20h,20h,20h,20h,20h,21h,21h
    db	21h,21h,21h,22h,22h,22h,22h,22h
    db	23h,23h,23h,23h,24h,24h,24h,24h
    db	25h,25h,25h,25h,26h,26h,26h,26h
    db	27h,27h,27h,27h,28h,28h,28h,29h
    db	29h,29h,29h,2ah,2ah,2ah,2bh,2bh
    db	2bh,2ch,2ch,2dh,2dh,2dh,2eh,2eh
    db	2eh,2fh,2fh,30h,30h,30h,31h,31h
    db	32h,32h,33h,33h,34h,34h,35h,35h
    db	36h,36h,37h,37h,38h,38h,39h,39h
    db	3ah,3bh,3bh,3ch,3dh,3dh,3eh,3fh
    db	3fh,40h,41h,42h,42h,43h,44h,45h
    db	46h,47h,48h,49h,49h,4ah,4bh,4dh
    db	4eh,4fh,50h,51h,52h,53h,55h,56h
    db	57h,59h,5ah,5ch,5dh,5fh,60h,62h
    db	64h,66h,68h,6ah,6ch,6eh,70h,72h
    db	75h,77h,7ah,7ch,7fh,82h,85h,89h
    db	8ch,90h,93h,97h,9ch,0a0h,0a5h,0aah
    db	0afh,0b5h,0bbh,0c1h,0c8h,0d0h,0d8h,0e0h
    db	0eah,0f4h,0ffh,0ffh
;
X0a78:	mov	a,rb2r4
    cjne	a,#0b1h,X0a82
    mov	a,#0ffh
    ljmp	X0ad8
;
X0a82:	jc	X0a89
    mov	a,#0ffh
    ljmp	X0ad8
;
X0a89:	mov	a,rb2r4
    clr	c
    subb	a,#13h
    jnc	X0a95
    mov	a,#1ch
    ljmp	X0ad8
;
X0a95:	mov	a,#17h
    mov	b,rb2r4
    mul	ab
    mov	rb3r0,b
    mov	rb2r7,a
    mov	a,#17h
    mov	b,rb2r3
    mul	ab
    xch	a,b
    add	a,rb2r7
    mov	rb2r7,a
    mov	a,rb3r0
    addc	a,#0
    rrc	a
    mov	rb3r0,a
    mov	a,rb2r7
    rrc	a
    mov	rb2r7,a
    mov	a,rb3r0
    rrc	a
    mov	rb3r0,a
    mov	a,rb2r7
    rrc	a
    mov	rb2r7,a
    mov	a,rb3r0
    rrc	a
    mov	rb3r0,a
    mov	a,rb2r7
    rrc	a
    mov	rb2r7,a
    mov	a,rb3r0
    rrc	a
    mov	rb3r0,a
    mov	a,rb2r7
    rrc	a
    addc	a,#0
    mov	rb2r7,a
X0ad8:	ret	
;
X0ad9:	mov	r0,#9
    jb	p2.4,X0ae2
    movx	@r0,a
    ljmp	X0af0
;
X0ae2:	mov	37h,a
    cjne	a,#0f8h,X0ae7
X0ae7:	jnc	X0aee
    setb	23h.7
    ljmp	X0af0
;
X0aee:	clr	23h.7
X0af0:	ret	
;
X0af1:	jnb	p2.4,X0b08
    mov	r0,#9
    mov	a,37h
    cjne	a,#5ah,X0afe
    ljmp	X0b00
;
X0afe:	jnc	X0b05
X0b00:	setb	p2.5
    ljmp	X0b07
;
X0b05:	clr	p2.5
X0b07:	movx	@r0,a
X0b08:	ret	
;
X0b09:	jnb	p2.4,X0b14
    jnb	23h.7,X0b14
    mov	r0,#9
    mov	a,#0f8h
    movx	@r0,a
X0b14:	ret	
;
cmd_GF:	mov	dptr,#group_F_dispatch_table
    mov	a,command
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
;X0b1e:	db	7eh,41h,44h,53h,61h,41h,41h,41h
;    db	6eh,10h,1bh,31h,39h,29h,41h,41h
group_F_dispatch_table:
     db cmd_F0 - group_F_dispatch_table
     db cmd_F1 - group_F_dispatch_table
     db cmd_F2 - group_F_dispatch_table
     db cmd_F3 - group_F_dispatch_table
     db cmd_F4 - group_F_dispatch_table
     db cmd_F5 - group_F_dispatch_table
     db cmd_F6 - group_F_dispatch_table
     db cmd_F7 - group_F_dispatch_table
     db cmd_F8 - group_F_dispatch_table
     db cmd_F9 - group_F_dispatch_table
     db cmd_FA - group_F_dispatch_table
     db cmd_FB - group_F_dispatch_table
     db cmd_FC - group_F_dispatch_table
     db cmd_FD - group_F_dispatch_table
     db cmd_FE - group_F_dispatch_table
     db cmd_FF - group_F_dispatch_table

;
cmd_F9:	lcall	X132f
    mov	r0,a
    mov	a,@r0
    lcall	X1338
    ljmp	group_F_exit
;
cmd_FA:	lcall	X132f
    mov	b,a
    lcall	X132f
    mov	r0,b
    mov	@r0,a
    ljmp	group_F_exit
;
cmd_FD:	mov	a,30h
    lcall	X1338
    ljmp	group_F_exit
;
cmd_FB:	mov	a,23h
    lcall	X1338
    ljmp	group_F_exit
;
cmd_FC:	mov	a,24h
    lcall	X1338
    ljmp	group_F_exit
;
cmd_F1:
cmd_F5:
cmd_F6:
cmd_F7:
cmd_FE:
cmd_FF:
    ljmp	group_F_exit
;
cmd_F2:	mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	group_F_exit
;
cmd_F3:	mov	r0,#10h
    movx	a,@r0
    anl	a,#0
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
    ljmp	group_F_exit
;
cmd_F4:	mov	a,#0a4h
    lcall	X1338
    mov	a,#6fh
    lcall	X1338
    ljmp	group_F_exit
;
cmd_F8:	mov	a,#0
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    ljmp	group_F_exit

cmd_F0:	mov	a,#5ah
    lcall	X0ad9
    lcall	X0af1
    mov	rb1r3,#5
    mov	rb1r2,#0
    mov	a,#60h
    mov	r0,#4
    movx	@r0,a
    setb	ex0
    ljmp	group_F_exit
;
group_F_exit:	clr	p1.2
    ljmp	X053a
;
int0_op5_data:	db	7fh,26h,1,26h,80h,0d9h,0ffh,0d9h
    db	0
;
cmd_G3:	jb	command_bit3,X0bdb
    jnb	command_bit2,X0be8
    mov	31h,#34h
    mov	32h,#12h
    ljmp	X0be8
;
X0bdb:	jnb	ti,X0bdb
    clr	ti
    lcall	X132f
    mov	sbuf,a
    ljmp	X053a
;
X0be8:	jnb	command_bit1,X0c00
    mov	tmod,#21h
    setb	24h.5
    mov	tl0,#2fh
    mov	th0,#0f8h
    mov	r5,#0
    mov	r6,#0
    mov	r7,#0
    setb	et0
    setb	tr0
X0c00:	mov	a,sbuf
    clr	ri
    mov	r1,#40h
    mov	r2,#40h
    mov	r4,#80h
    ljmp	X0c2e
;
X0c0d:	jnb	ti,X0c2e
    jnb	p1.1,X0c2e
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    jb	command_bit2,X0c2a
    clr	et0
    clr	tr0
    mov	31h,#0
    mov	32h,#0
    clr	24h.5
    ljmp	X053a
;
X0c2a:	clr	ti
    mov	sbuf,a
X0c2e:	jb	ri,X0c3b
    cjne	r4,#80h,X0c36
    sjmp	X0c0d
;
X0c36:	jnb	p1.0,X0c57
    sjmp	X0c0d
;
X0c3b:	jnb	command_bit1,X0c4e
    clr	tr0
    mov	a,r5
    lcall	X0c77
    mov	a,r6
    lcall	X0c77
    mov	a,r7
    lcall	X0c77
    setb	tr0
X0c4e:	mov	a,sbuf
    lcall	X0c77
    clr	ri
    sjmp	X0c0d
;
X0c57:	mov	a,r2
    mov	r0,a
    mov	a,@r0
    inc	r2
    inc	r4
    cjne	r2,#0c0h,X0c61
    mov	r2,#40h
X0c61:	mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    jnb	command_bit0,X0c75
    mov	r0,#8
    movx	a,@r0
    anl	a,#3
    movx	@r0,a
    orl	a,#80h
    movx	@r0,a
    anl	a,#7fh
    movx	@r0,a
X0c75:	sjmp	X0c0d
;
X0c77:	cjne	r4,#0,X0c7d
    ljmp	X0c85
;
X0c7d:	mov	@r1,a
    inc	r1
    dec	r4
    cjne	r1,#0c0h,X0c85
    mov	r1,#40h
X0c85:	ret	
;
X0c86:	mov	r0,#2
    mov	a,#0feh
    movx	@r0,a
    setb	23h.5
    mov	a,sbuf
    clr	ri
    mov	r1,#40h
    mov	r2,#40h
    mov	r4,#80h
    mov	31h,#34h
    mov	32h,#12h
    ret	
;
X0c9e:	mov	31h,#34h
    mov	32h,#12h
    mov	a,38h
    cjne	a,#52h,X0cb1
    mov	a,39h
    cjne	a,#86h,X0cb1
    ljmp	X0d13
;
X0cb1:	clr	p1.2
    jb	p1.1,X0cf2
    jnb	p1.6,X0ce7
    jb	ri,X0cfb
    cjne	r4,#80h,X0cf3
X0cc9:	jnb	ti,X0cb1
    mov	r0,#2
    movx	a,@r0
    setb	p1.2
    jnb	acc.6,X0cb1
    mov	r0,#1
    movx	a,@r0
    clr	ti
    mov	sbuf,a
    sjmp	X0cb1
;
X0ce7:	mov	r0,#1
    movx	a,@r0
    clr	23h.5
    mov	31h,#0
    mov	32h,#0
X0cf2:	ret	
;
X0cf3:	mov	r0,#2
    movx	a,@r0
    jb	acc.7,X0d04
    sjmp	X0cc9
;
X0cfb:	mov	a,sbuf
    lcall	X0c77
    clr	ri
    sjmp	X0cc9
;
X0d04:	mov	a,r2
    mov	r0,a
    mov	a,@r0
    inc	r2
    inc	r4
    cjne	r2,#0c0h,X0d0e
    mov	r2,#40h
X0d0e:	mov	r0,#2
    movx	@r0,a
    sjmp	X0cc9
;
X0d13:	clr	p1.2
    jb	p1.1,X0d5e
    jnb	p1.6,X0d53
    jnb	2fh.5,X0d2b
    jnb	ti,X0d13
X0d2b:	mov	r0,#2
    movx	a,@r0
    setb	p1.2
    jnb	acc.7,X0d13
    mov	r0,#2
    movx	a,@r0
    jnb	acc.6,X0d13
    mov	r0,#1
    movx	a,@r0
    clr	ea
    clr	p2.7
    mov	r0,#2
    movx	@r0,a
    setb	p2.7
    setb	ea
    sjmp	X0d13
;
X0d53:	mov	r0,#1
    movx	a,@r0
    clr	23h.5
    mov	31h,#0
    mov	32h,#0
X0d5e:	ret	
;
cmd_G2:	clr	2fh.4
    jb	command_bit3,X0d6a
    jb	command_bit2,X0d8c
    ljmp	X0e04
;
X0d6a:	lcall	X0af1
    setb	24h.2
    clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
    mov	a,rb1r6
    mov	21h,a
    mov	r0,#0bh
    movx	@r0,a
    mov	a,rb1r7
    mov	22h,a
    mov	r0,#0ch
    movx	@r0,a
    ljmp	X0dd1
;
X0d8c:	lcall	X0af1
    jb	2fh.0,X0dab
X0d92:	jnb	p1.1,X0d92
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r1,a
X0d9c:	jnb	p1.1,X0d9c
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	rb2r2,a
    setb	24h.1
    ljmp	X0e1a
;
X0dab:	clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
X0db7:	jnb	p1.1,X0db7
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	21h,a
    mov	r0,#0bh
    movx	@r0,a
X0dc4:	jnb	p1.1,X0dc4
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	22h,a
    mov	r0,#0ch
    movx	@r0,a
X0dd1:	setb	23h.1
    mov	rb1r2,#5
    lcall	X1317
    mov	r0,#8
    movx	a,@r0
    orl	a,#40h
    movx	@r0,a
    anl	a,#0bfh
    movx	@r0,a
    clr	2fh.0
    setb	ex1
    lcall	X134a
    clr	ea
    mov	r0,#8
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#16h
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    mov	r0,#0eh
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    setb	ea
    ljmp	X053a
;
X0e04:	mov	a,#61h
    mov	r0,#4
    movx	@r0,a
    mov	r0,#17h
X0e0b:	movx	a,@r0
    jnb	acc.7,X0e0b
    mov	r0,#1bh
    movx	a,@r0
X0e12:	jb	p1.0,X0e12
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
X0e1a:	ljmp	X053a
;
cmd_G9:	lcall	X0af1
    clr	2fh.4
    jnb	command_bit3,X0e43
    mov	rb1r2,#5
    setb	23h.1
    mov	r0,#8
    movx	a,@r0
    orl	a,#40h
    movx	@r0,a
    anl	a,#0bfh
    movx	@r0,a
    lcall	X134a
    jb	command_bit0,X0e3e
    setb	24h.2
    ljmp	X0e55
;
X0e3e:	clr	24h.2
    ljmp	X0e55
;
X0e43:	mov	rb1r2,#4
    setb	23h.0
    lcall	X1341
    jb	command_bit0,X0e53
    setb	24h.2
    ljmp	X0e55
;
X0e53:	clr	24h.2
X0e55:	clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
    mov	a,rb1r6
    mov	r0,#0bh
    movx	@r0,a
    mov	a,rb1r7
    mov	r0,#0ch
    movx	@r0,a
    mov	31h,#34h
    mov	32h,#12h
    clr	2fh.0
    lcall	X1317
    setb	ex1
    clr	ea
    mov	r0,#8
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#16h
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    mov	r0,#0eh
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    setb	ea
    ljmp	X053a
;
cmd_G1:	clr	2fh.4
    jb	command_bit3,X0e9e
    jb	command_bit2,X0ec0
    ljmp	X0f77
;
X0e9e:	lcall	X0af1
    setb	24h.2
    clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
    mov	a,rb1r6
    mov	21h,a
    mov	r0,#0bh
    movx	@r0,a
    mov	a,rb1r7
    mov	22h,a
    mov	r0,#0ch
    movx	@r0,a
    ljmp	X0efa
;
X0ec0:	lcall	X0af1
    jnb	24h.2,X0edc
    jnb	command_bit1,X0ecb
    clr	ex0
X0ecb:	lcall	X132f
    mov	rb2r1,a
    lcall	X132f
    mov	rb2r2,a
    setb	24h.1
    setb	ex0
    ljmp	X0f24
;
X0edc:	clr	24h.1
    clr	ea
    mov	r0,#8
    mov	a,#1
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    setb	ea
    lcall	X132f
    mov	21h,a
    mov	r0,#0bh
    movx	@r0,a
    lcall	X132f
    mov	22h,a
    mov	r0,#0ch
    movx	@r0,a
X0efa:	jb	command_bit1,X0f27
    setb	23h.0
    mov	rb1r2,#4
    lcall	X1317
    clr	2fh.0
    setb	ex1
    lcall	X1341
    clr	ea
    mov	r0,#8
    mov	a,#4
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#16h
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    mov	r0,#0eh
    movx	a,@r0
    anl	a,#4
    movx	@r0,a
    setb	ea
X0f24:	ljmp	X053a
;
X0f27:	clr	2fh.0
    mov	rb1r3,#2
    mov	rb1r2,#2
    lcall	X1317
    lcall	X1326
    jb	command_bit0,X0f54
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0f47:	movx	a,@r0
    jnb	acc.6,X0f47
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    mov	r3,#4
    ljmp	X0f72
;
X0f54:	setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0f63:	movx	a,@r0
    jnb	acc.6,X0f63
    mov	r0,#1fh
    movx	a,@r0
    mov	r2,a
    mov	r0,#19h
    movx	@r0,a
    mov	r5,#1
    mov	r3,#1
X0f72:	setb	ex0
    ljmp	X053a
;
X0f77:	mov	a,#60h
    mov	r0,#4
    movx	@r0,a
X0f7c:	jnb	p1.1,X0f7c
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    mov	r0,#19h
    movx	@r0,a
    ljmp	X053a
;
cmd_G7:	lcall	X0af1
    clr	2fh.4
    jb	command_bit3,X0f95
    jb	command_bit2,X0fa0
X0f95:	setb	24h.2
    mov	21h,rb1r6
    mov	22h,rb1r7
    ljmp	X0fd1
;
X0fa0:	jb	24h.2,X0fa6
    ljmp	X0fb9
;
X0fa6:	clr	ex0
    lcall	X132f
    mov	rb2r1,a
    lcall	X132f
    mov	rb2r2,a
    setb	24h.1
    setb	ex0
    ljmp	X053a
;
X0fb9:	clr	24h.1
    lcall	X132f
    mov	21h,a
    lcall	X132f
    mov	22h,a
    setb	p1.2
X0fd1:	clr	2fh.0
    jnb	command_bit1,X0fdc
    mov	rb1r3,#3
    ljmp	X0fdf
;
X0fdc:	mov	rb1r3,#4
X0fdf:	mov	rb1r2,#2
    lcall	X1317
    lcall	X1326
    jnb	command_bit0,X100c
    setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X0ffa:	movx	a,@r0
    jnb	acc.6,X0ffa
    mov	r0,#1fh
    movx	a,@r0
    mov	r2,a
    mov	r0,#19h
    movx	@r0,a
    mov	r5,#1
    mov	r3,#1
    ljmp	X102d
;
X100c:	setb	p1.5
    clr	p1.5
    mov	r0,#0fh
X101b:	movx	a,@r0
    jnb	acc.6,X101b
    mov	r0,#1fh
    movx	a,@r0
    mov	r6,a
    jnb	command_bit1,X102b
    mov	r3,#3
    ljmp	X102d
;
X102b:	mov	r3,#4
X102d:	setb	ex0
    ljmp	X053a
;
cmd_G8:	lcall	X0af1
    clr	2fh.0
    lcall	X132f
    mov	21h,a
    lcall	X132f
    mov	22h,a
    mov	rb1r3,#1
    mov	rb1r2,#2
    lcall	X1317
    setb	ex0
    ljmp	X053a
;
cmd_GD:	mov	dptr,#group_D_dispatch_table
    mov	a,command
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
;X1058:	db	50h,3ch,10h,41h,94h,7fh,0e0h,10h
;    db	25h,4bh,46h,10h,0fdh,0f2h,13h,1ch
group_D_dispatch_table:
     db cmd_D0 - group_D_dispatch_table
     db cmd_D1 - group_D_dispatch_table
     db cmd_D2 - group_D_dispatch_table
     db cmd_D3 - group_D_dispatch_table
     db cmd_D4 - group_D_dispatch_table
     db cmd_D5 - group_D_dispatch_table
     db cmd_D6 - group_D_dispatch_table
     db cmd_D7 - group_D_dispatch_table
     db cmd_D8 - group_D_dispatch_table
     db cmd_D9 - group_D_dispatch_table
     db cmd_DA - group_D_dispatch_table
     db cmd_DB - group_D_dispatch_table
     db cmd_DC - group_D_dispatch_table
     db cmd_DD - group_D_dispatch_table
     db cmd_DE - group_D_dispatch_table
     db cmd_DF - group_D_dispatch_table

cmd_D2:
cmd_D7:
cmd_DB:
    ljmp	group_D_exit
;
cmd_DE:	mov	r0,#5
    movx	a,@r0
    setb	acc.1
    movx	@r0,a
    ljmp	group_D_exit
;
cmd_DF:	mov	r0,#5
    movx	a,@r0
    clr	acc.1
    movx	@r0,a
    ljmp	group_D_exit
;
cmd_D8:	jb	command_bit1,cmd_DA
    jb	23h.4,X1087
    clr	a
    ljmp	X1089
;
X1087:	mov	a,#0ffh
X1089:	jb	p1.0,X1089
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    ljmp	group_D_exit
;
cmd_D1:	setb	23h.4
    ljmp	group_D_exit
;
cmd_D3:	clr	23h.4
    ljmp	group_D_exit
;
cmd_DA:	clr	24h.2
    ljmp	group_D_exit
;
cmd_D9:	clr	24h.4
    ljmp	group_D_exit
;
cmd_D0:	setb	2fh.0
    mov	r0,#4
    movx	a,@r0
    jb	acc.2,X10bb
    clr	ex0
    jnb	2fh.1,X10d4
    lcall	X0b09
    ljmp	group_D_exit
;
X10bb:	mov	r0,#8
    movx	a,@r0
    anl	a,#0e7h
    orl	a,#42h
    movx	@r0,a
    mov	2eh,#64h
X10c6:	djnz	2eh,X10c6
    anl	a,#0a7h
    movx	@r0,a
    clr	ex1
    jnb	2fh.1,X10d4
    lcall	X0b09
X10d4:	ljmp	group_D_exit
;
cmd_D5:	mov	r0,#10h
    movx	a,@r0
    anl	a,#0e7h
    orl	a,#2
    movx	@r0,a
    setb	2fh.1
    clr	ex1
    jnb	2fh.0,X10e9
    lcall	X0b09
X10e9:	ljmp	group_D_exit
;
cmd_D4:	lcall	X0af1
    clr	2fh.0
    mov	r0,#4
    movx	a,@r0
    jb	acc.2,X10fc
    setb	ex0
    ljmp	group_D_exit
;
X10fc:	mov	r0,#8
    movx	a,@r0
    jnb	acc.1,X1131
    mov	r0,#0ah
    movx	a,@r0
    push	acc
    mov	r0,#0dh
    movx	a,@r0
    push	acc
    mov	r0,#8
    movx	a,@r0
    orl	a,#3
    movx	@r0,a
    anl	a,#0feh
    movx	@r0,a
    mov	r0,#0ch
    pop	acc
    movx	@r0,a
    mov	r0,#0bh
    pop	acc
    movx	@r0,a
    mov	r0,#8
    mov	a,#6
    movx	@r0,a
    mov	a,#0
    movx	@r0,a
    mov	r0,#0ch
    mov	a,rb1r7
    movx	@r0,a
    mov	r0,#0bh
    mov	a,rb1r6
    movx	@r0,a
X1131:	setb	ea
    setb	ex1
    ljmp	group_D_exit
;
cmd_D6:	lcall	X0af1
    clr	2fh.1
    mov	r0,#10h
    movx	a,@r0
    anl	a,#0e5h
    movx	@r0,a
    setb	ea
    setb	ex1
    ljmp	group_D_exit
;
cmd_DD:	mov	38h,#0
    mov	39h,#0
    clr	2fh.5
    ljmp	group_D_exit
;
cmd_DC:	mov	38h,#52h
    mov	39h,#86h
    clr	2fh.5
X115d:	jnb	p1.1,X115d
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    cjne	a,#1,group_D_exit
    setb	2fh.5
    ljmp	group_D_exit
;
group_D_exit:	clr	p1.2
    setb	ea
    ljmp	X053a
;
cmd_GE:	mov	dptr,#group_E_dispatch_table
    mov	a,command
    anl	a,#0fh
    movc	a,@a+dptr
    jmp	@a+dptr
;
;X1187:	db	13h,5fh,2dh,7ah,25h,10h,10h,10h
;    db	1dh,10h,10h,10h,10h,10h,10h,10h
group_E_dispatch_table:
     db cmd_E0 - group_E_dispatch_table
     db cmd_E1 - group_E_dispatch_table
     db cmd_E2 - group_E_dispatch_table
     db cmd_E3 - group_E_dispatch_table
     db cmd_E4 - group_E_dispatch_table
     db cmd_E5 - group_E_dispatch_table
     db cmd_E6 - group_E_dispatch_table
     db cmd_E7 - group_E_dispatch_table
     db cmd_E8 - group_E_dispatch_table
     db cmd_E9 - group_E_dispatch_table
     db cmd_EA - group_E_dispatch_table
     db cmd_EB - group_E_dispatch_table
     db cmd_EC - group_E_dispatch_table
     db cmd_ED - group_E_dispatch_table
     db cmd_EE - group_E_dispatch_table
     db cmd_EF - group_E_dispatch_table

;
cmd_E5:
cmd_E6:
cmd_E7:
cmd_E9:
cmd_EA:
cmd_EB:
cmd_EC:
cmd_ED:
cmd_EE:
cmd_EF:
    ljmp	group_E_exit
;
cmd_E0:	lcall	X132f
    cpl	a
    lcall	X1338
    ljmp	group_E_exit
;
cmd_E8:	mov	a,2ah
    lcall	X1338
    ljmp	group_E_exit
;
cmd_E4:	lcall	X132f
    mov	2ah,a
    ljmp	group_E_exit
;
cmd_E2:	mov	rb1r2,#3
    lcall	X1317
    lcall	X132f
    xrl	a,26h
    add	a,25h
    mov	25h,a
    mov	a,26h
    rr	a
    rr	a
    mov	26h,a
    mov	a,25h
    mov	r0,#1dh
    movx	@r0,a
    clr	2fh.0
    setb	p1.5
    clr	p1.5
X11dd:	jb	p1.0,X11dd
    nop	
    setb	2fh.0
    ljmp	group_E_exit
;
cmd_E1:	mov	dptr,#dspver
    clr	a
    movc	a,@a+dptr
X11eb:	jb	p1.0,X11eb
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    mov	a,#1
    movc	a,@a+dptr
X11f6:	jb	p1.0,X11f6
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    ljmp	group_E_exit
;
cmd_E3:	mov	dptr,#copyright_string
    clr	a
X1205:	mov	b,a
    movc	a,@a+dptr
    lcall	X1338
    jz	group_E_exit
    mov	a,b
    inc	a
    sjmp	X1205
;
group_E_exit:	clr	p1.2
    ljmp	command_loop
;
X1221:	mov	a,r6
    rlc	a
    jc	X124c
    rlc	a
    mov	r6,a
    mov	a,r5
    jc	X1239
    rrc	a
    mov	r5,a
    jnz	X1231
    inc	r5
    sjmp	X1273
;
X1231:	add	a,r2
    jnc	X1236
    mov	a,#0ffh
X1236:	mov	r2,a
    sjmp	X1273
;
X1239:	clr	c
    rrc	a
    add	a,r5
    add	a,r2
    jnc	X1241
    mov	a,#0ffh
X1241:	mov	r2,a
    cjne	r5,#20h,X1247
    sjmp	X1273
;
X1247:	mov	a,r5
    add	a,r5
    mov	r5,a
    sjmp	X1273
;
X124c:	rlc	a
    mov	r6,a
    mov	a,r5
    jc	X1261
    rrc	a
    mov	r5,a
    jnz	X1258
    inc	r5
    sjmp	X1273
;
X1258:	xch	a,r2
    clr	c
    subb	a,r2
    jnc	X125e
    clr	a
X125e:	mov	r2,a
    sjmp	X1273
;
X1261:	clr	c
    rrc	a
    add	a,r5
    xch	a,r2
    clr	c
    subb	a,r2
    jnc	X126a
    clr	a
X126a:	mov	r2,a
    cjne	r5,#20h,X1270
    sjmp	X1273
;
X1270:	mov	a,r5
    add	a,r5
    mov	r5,a
X1273:	mov	a,r2
    mov	r0,#19h
    movx	@r0,a
    ret	
;
X1278:	mov	a,r5
    clr	c
    rrc	a
    mov	27h,a
    mov	a,r6
    mov	rb2r0,a
    swap	a
    mov	r6,a
    anl	a,#7
    mov	28h,a
    mov	b,r5
    mul	ab
    add	a,27h
    mov	29h,a
    mov	a,rb2r0
    rlc	a
    jc	X129c
    mov	a,29h
    add	a,r2
    jnc	X12a3
    mov	a,#0ffh
    ljmp	X12a3
;
X129c:	mov	a,r2
    clr	c
    subb	a,29h
    jnc	X12a3
    clr	a
X12a3:	mov	r2,a
    mov	a,28h
    jz	X12b7
    clr	c
    subb	a,#5
    jc	X12be
    mov	a,r5
    rl	a
    cjne	a,#10h,X12bd
    mov	a,#8
    ljmp	X12bd
;
X12b7:	mov	a,27h
    jnz	X12bd
    mov	a,#1
X12bd:	mov	r5,a
X12be:	mov	a,r2
    mov	r0,#19h
    movx	@r0,a
    ret	
;
X12c3:	mov	a,r5
    clr	c
    rrc	a
    mov	27h,a
    mov	a,r6
    mov	rb2r0,a
    rl	a
    rl	a
    cjne	r3,#1,X12d5
    anl	a,#1
    ljmp	X12d6
;
X12d5:	rl	a
X12d6:	mov	r6,a
    anl	a,#3
    mov	28h,a
    mov	b,r5
    mul	ab
    add	a,27h
    mov	29h,a
    mov	a,rb2r0
    rlc	a
    jc	X12f1
    mov	a,29h
    add	a,r2
    jnc	X12f8
    mov	a,#0ffh
    ljmp	X12f8
;
X12f1:	mov	a,r2
    clr	c
    subb	a,29h
    jnc	X12f8
    clr	a
X12f8:	mov	r2,a
    mov	a,28h
    jz	X130b
    cjne	a,#3,X1312
    cjne	r5,#10h,X1306
    ljmp	X1312
;
X1306:	mov	a,r5
    rl	a
    ljmp	X1311
;
X130b:	mov	a,27h
    jnz	X1311
    mov	a,#1
X1311:	mov	r5,a
X1312:	mov	a,r2
    mov	r0,#19h
    movx	@r0,a
    ret	
;
X1317:	push	acc
    mov	r0,#4
    movx	a,@r0
    anl	a,#0f0h
    orl	a,rb1r2
    mov	rb1r2,a
    movx	@r0,a
    pop	acc
    ret	
;
X1326:	mov	r0,#0eh
    mov	a,#7
    movx	@r0,a
    mov	a,#4
    movx	@r0,a
    ret	
;
X132f:	jnb	p1.1,X132f
    mov	r0,#0
    nop	
    nop	
    movx	a,@r0
    ret	
;
X1338:	jb	p1.0,X1338
    mov	r0,#0
    nop	
    nop	
    movx	@r0,a
    ret	
;
X1341:	mov	r0,#0eh
    mov	a,#7
    movx	@r0,a
    mov	a,#6
    movx	@r0,a
    ret	
;
X134a:	mov	r0,#16h
    mov	a,#7
    movx	@r0,a
    mov	a,#6
    movx	@r0,a
    ret	
;
X1353:	mov	r0,#0eh
    mov	a,#3
    movx	@r0,a
    mov	a,#2
    movx	@r0,a
    ret	
;
X135c:	mov	r0,#16h
    mov	a,#3
    movx	@r0,a
    mov	a,#2
    movx	@r0,a
    ret	

copyright_string:	db	43h,4fh,50h,59h,52h,49h,47h,48h
    db	54h,20h,28h,43h,29h,20h,43h,52h
    db	45h,41h,54h,49h,56h,45h,20h,54h
    db	45h,43h,48h,4eh,4fh,4ch,4fh,47h
    db	59h,20h,4ch,54h,44h,2ch,20h,31h
    db	39h,39h,32h,2eh,0
dspver:	db	4,0dh

REPT (0x2000 - $)
DB 0xFF
ENDM

;
;	Register/Memory Equates
;
rb0r0	equ	0
rb1r0	equ	8
rb1r1	equ	9
rb1r2	equ	0ah
rb1r3	equ	0bh
rb1r4	equ	0ch
rb1r5	equ	0dh
rb1r6	equ	0eh
rb1r7	equ	0fh
rb2r0	equ	10h
rb2r1	equ	11h
rb2r2	equ	12h
rb2r3	equ	13h
rb2r4	equ	14h
rb2r5	equ	15h
rb2r6	equ	16h
rb2r7	equ	17h
rb3r0	equ	18h
rb3r1	equ	19h
rb3r2	equ	1ah
command	equ	20h
;
;	Memory bit Equates
;
command_bit0	equ	0
command_bit1	equ	1
command_bit2	equ	2
command_bit3	equ	3
;
    end
;

